<?xml version="1.0" encoding="UTF-8"?>

<!--
- Fichiers de configuration du logiciel XMetaL (version 3 et 4 Author) de Blast Radius (http://www.blastradius.com) :
	interface en langue française pour l'édition de documents XML conformes à la DTD EAD 2002 -

- Configuration files for Blast Radius XMetaL software (see http://www.blastradius.com) : interface created in order to help French-speaking XMetaL users to edit XML/EAD 2002 instances -

Copyright (C) 2004, SOLLAN France et Centre historique des Archives nationales de France


SOLLAN France
27 bis rue du Progrès
F - 93100 Montreuil, France
contact@sollan.com

Centre historique des Archives nationales
60 rue des Francs-Bourgeois
F - 75 141 Paris CEDEX 03, France
sntic.chan.archives@culture.gouv.fr


This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
or see : http://www.fsf.org/licenses/lgpl.html

-->
<!-- Fichier de macros -->


<!DOCTYPE MACROS SYSTEM "macros.dtd">
<MACROS PROJECTID="a0074ad6-5a51-4924-b49c-b673590b5d2a">
	<MACRO name="Exposant" lang="JScript" key="Alt+Shift+E" hide="false" id="1209"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet de mettre en exposant la sélection.
	*/
	if ( Selection.CanSurround("emph") )
	{
		Selection.Surround("emph");
		Selection.ElementAttribute("render", "emph", 0) = "super";
	}]]></MACRO>
	<MACRO name="Gras" lang="JScript" key="Alt+Shift+G" hide="false" id="20403"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet de mettre en gras la sélection.
	*/
	if ( Selection.CanSurround("emph") )
	{
		Selection.Surround("emph");
		Selection.ElementAttribute("render", "emph", 0) = "bold";
	}]]></MACRO>
	<MACRO name="Indice" lang="JScript" key="Alt+Shift+B" hide="false" id="1208"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet de mettre en indice la sélection.
	*/
	if ( Selection.CanSurround("emph") )
	{
		Selection.Surround("emph");
		Selection.ElementAttribute("render", "emph", 0) = "sub";
	}]]></MACRO>
	<MACRO name="Insérer un composant simple" lang="JScript" key="Ctrl+Alt+C" hide="false" id="1710"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet d'appeler le formulaire pour un c simplifié
		et de le gérer par la suite.
	*/
	if(Selection.CanInsert("c"))
	{
		var dlg=Application.CreateFormDlg(Application.Path+"/ead2002/c_simple.xft");
		var status = dlg.DoModal();
		if ( status == 1 )
		{
			// On récupère les informations provenant des quatres champs texte
			var unitid = dlg.txtUnitid.Text;
			var unittitle = dlg.txtUnittitle.Text;
			var unitdate = dlg.txtUnitdate.Text;
			var normal = dlg.txtNormal.Text;

			// On poursuit seulement si l'utilisateur a saisi au moins
			// un unittitle, un unitid ou un unitdate
			if ( !isEmpty(unitid) || !isEmpty(unittitle) || !isEmpty(unitdate) )
			{
				// On insère un c
				Selection.InsertElement("c");

				// On insère un did
				Selection.InsertElement("did");

				// On insère les sous-éléments saisis
				if ( !isEmpty(unitid) ) { insertTextElement("unitid", unitid); Selection.MoveRight(); }
				if ( !isEmpty(unittitle) ) { insertTextElement("unittitle", unittitle); Selection.MoveRight(); }
				if ( !isEmpty(unitdate) )
				{
					insertTextElement("unitdate", unitdate);
					// On doit aussi insérer l'attribut normal si nécessaire
					if ( !isEmpty(normal) ) Selection.ElementAttribute("normal", "unitdate", 0) = normal;
					Selection.MoveRight();
				}
			}
		}
		dlg = null;
	}]]></MACRO>
	<MACRO name="Insérer un lien hypertexte" lang="JScript" key="Alt+Shift+L" hide="false" id="1349"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet d'appeler le formulaire pour un lien hypertexte
		et de le gérer par la suite.
	*/

	if ( Selection.CanSurround("ref") )
	{
		var dlg=Application.CreateFormDlg(Application.Path+"/ead2002/lien.xft");
		var status = dlg.DoModal();
		if ( status == 1 )
		{
			// On doit d'abord déterminer si c'est un lien interne ou externe
			if ( dlg.radExterne.Value==0 )
			{
				// Un lien externe: extref, attribut ref
				if ( !isEmpty(dlg.txtExterne.Text) )
				{
					Selection.Surround("extref");
					Selection.ElementAttribute("href", "extref", 0) = dlg.txtExterne.Text;
				}
			}
			else
			{
			// Un lien interne: ref, attribut target
				if ( !isEmpty(dlg.cboInterne.TextValue()) )
				{
					Selection.Surround("ref");
					Selection.ElementAttribute("target", "ref", 0) = dlg.cboInterne.TextValue();
				}
			}
		}
		dlg = null;
	}]]></MACRO>
	<MACRO name="Insertion deux points" lang="JScript" key="Alt+/" hide="false" id="1413"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet un ":" précédé d'un espace insécable.
	*/
	if ( Selection.CanInsertText )
	{
		Selection.Text = '&#xA0;:';
	}]]></MACRO>
	<MACRO name="Insertion espace insécable" lang="JScript" key="Alt+Space" hide="false" id="20304"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet d'insérer un espace insécable.
	*/
	if ( Selection.CanInsertText )
	{
		Selection.Text = '&#xA0;';
	}]]></MACRO>
	<MACRO name="Insertion guillemets fermant" lang="JScript" key="Alt+4" hide="false" id="22014"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet des guillemets français fermant
		précédés d'un espace insécable.
	*/
	if ( Selection.CanInsertText )
	{
		Selection.Text = '&#xA0;&#xBB;';
	}]]></MACRO>
	<MACRO name="Insertion guillemets ouvrant" lang="JScript" key="Alt+3" hide="false" id="22013"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet des guillemets français ouvrant
		suivis d'un espace insécable.
	*/
	if ( Selection.CanInsertText )
	{
		Selection.Text = '&#xAB;&#xA0;';
	}]]></MACRO>
	<MACRO name="Insertion point-virgule" lang="JScript" key="Alt+." hide="false" id="1404"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet un ";" précédé d'un espace insécable.
	*/
	if ( Selection.CanInsertText )
	{
		Selection.Text = '&#xA0;;';
	}]]></MACRO>
	<MACRO name="Insertion tiret cadratin" lang="JScript" key="Alt+6" hide="false" id="22023"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet un tiret cadratin.
	*/
	if ( Selection.CanInsertText )
	{
		Selection.Text = '&#x2014;';
	}]]></MACRO>
	<MACRO name="Italique" lang="JScript" key="Alt+Shift+I" hide="false" id="20411"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet de mettre en italique la sélection.
	*/
	if ( Selection.CanSurround("emph") )
	{
		Selection.Surround("emph");
		Selection.ElementAttribute("render", "emph", 0) = "italic";
	}]]></MACRO>
	<MACRO name="Note" lang="JScript" key="Alt+Shift+N" hide="false" id="1800"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Insère une note.
	*/
	if ( Selection.CanInsert("note") )
	{
		Selection.InsertWithTemplate("note");
	}]]></MACRO>
	<MACRO name="On_Before_Document_Preview" lang="JScript" hide="false"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

// This macro gets called when the user has selected Page Preview view,
  // or Preview in Browser.  The BrowserURL property is the URL that will
  // be passed to the browser.  On entry, it contains the URL of a temporary
  // copy of the XML file being edited.  We apply an XSLT stylesheet to create
  // an HTML file and set BrowserURL to be the path to this file.

  // If the doc is not saved, set the temp file path to "Document".
  var strTempFilePath;
  if ( ActiveDocument.Path ) {
    strTempFilePath = ActiveDocument.Path;
  } else {
    strTempFilePath = Application.Path + "\\Document";
  }

  // Create the document property for PreviewTempFile.
  var ndlProperties = ActiveDocument.CustomDocumentProperties;
  var ndProperty    = ndlProperties.item( "PreviewTempFile" );

  // Reuse an existing temp file, or create a new one.
  if ( ndProperty ) {
    strTempName = ndProperty.value;
  } else {
    strTempName = Application.UniqueFileName( strTempFilePath, "XM", "htm" );
    ndlProperties.Add ( "PreviewTempFile", strTempName );
  }

  // Construct path to XML document to be previewed from supplied URL
  var xmlPath = Application.URLtoPath(ActiveDocument.BrowserURL);

  // Path to XSLT stylesheet is hard coded
  var xslPath = Application.Path + "\\Display\\eadcbs2.xsl";

  // HTML output path is the temp file.
  var htmPath = strTempName;

  // Apply XSLT stylesheet
  var xt = new ActiveXObject("XT.Application");
  xt.transform( xmlPath, xslPath, htmPath );

  // Change the URL to be sent to the browser to the HTML output file
  ActiveDocument.BrowserURL = htmPath;]]></MACRO>
	<MACRO name="On_Macro_File_Load" lang="JScript" hide="false"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro est en fait une collection de fonctions accessibles
		depuis toutes les macros associées à une DTD. On y définit des
		fonctions générales et utilitaires.
	*/


	// Retourne, dans un objet Dictionary, la liste des éléments ouverts
	function getOpenElementsHash(el)
	{
		var ret = new ActiveXObject("Scripting.Dictionary");
		if ( el == null ) return ret;
		ret.add(el.tagName, el);
		var current = el;
		while ( current.parentNode != null && current.parentNode.nodeType == 1 )
		{
			if ( !ret.Exists(current.parentNode.tagName) ) ret.add(current.parentNode.tagName, current.parentNode);
			current = current.parentNode;
		}
		return ret;
	}


	// Cette fonction vérifie si une chaîne de caractères ne contient que des blancs
	function isEmpty(str)
	{
		if ( str == null ) return true;
		//var re = /^\s*$/g;
		if ( str != "" ) return false;
		else return true;
	}

	// Cette fonction crée un éléménet (au point de curseur) 'name' et insère le texte 'str' à l'intérieur
	function insertTextElement(name, str)
	{
		if ( name != null && str != null )
		{
			Selection.InsertElement(name);
			Selection.TypeText(str);
		}
	}]]></MACRO>
	<MACRO name="On_Update_UI" lang="JScript" hide="false"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro est appelée à chaque fois qu'un événement d'interface se produit dans
		XMetaL, en particulier lorsque le curseur chage de position dans le document.

		C'est donc ici que l'on active ou désactive les macros, en fonction de l'endroit
		où se situe le curseur.
	*/

	// Les macros suivantes sont actives seulement si on peut insérer du texte
	if ( !Selection.CanInsertText )
	{
		Application.DisableMacro("Insertion espace insécable");
		Application.DisableMacro("Insertion deux points");
		Application.DisableMacro("Insertion point-virgule");
		Application.DisableMacro("Insertion guillemets ouvrant");
		Application.DisableMacro("Insertion guillemets fermant");
		Application.DisableMacro("Insertion tiret cadratin");
	}

	// Pour les suivantes, c'est seulement si on peut insérer l'élément
	// en question à l'endroit où se situe le curseur
	if ( !Selection.CanSurround("emph") )
	{
		Application.DisableMacro("Italique");
		Application.DisableMacro("Gras");
		Application.DisableMacro("Exposant");
		Application.DisableMacro("Indice");
	}
	if ( !Selection.CanSurround("title") ) { Application.DisableMacro("Titre cité"); }
	if ( !Selection.CanSurround("unitdate") ) { Application.DisableMacro("Unitdate"); }
	if ( !Selection.CanSurround("ref") ) { Application.DisableMacro("Insérer un lien hypertexte"); }
	if ( !Selection.CanInsert("note") ) { Application.DisableMacro("Note"); }
	if ( !Selection.CanInsert("c") ) { Application.DisableMacro("Insérer un composant simple"); }]]></MACRO>
	<MACRO name="Titre cité" lang="JScript" key="Alt+Shift+C" hide="false" id="20406"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet de mettre en titre la sélection.
	*/
	if ( Selection.CanSurround("title") )
	{
		Selection.Surround("title");
	}]]></MACRO>
	<MACRO name="Unitdate" lang="JScript" key="Alt+Shift+D" hide="false" id="1917"><![CDATA[// XMetal Author JScript Macro File

                                                                                                       
                                                            
                                                        
                                                                  
                                                        
                                                                    
                     

/*
		Cette macro permet de mettre en unitdate la sélection.
	*/
	if ( Selection.CanSurround("unitdate") )
	{
		Selection.Surround("unitdate");
	}]]></MACRO>
</MACROS>
